import { usePolling } from "../hook/api";
import { useUserStateReducer } from "../reducer/user";

export default function useUserApi() {
    const [state, dispatchState] = useUserStateReducer();

    const useGetUser = () => {
        const onSuccess = (userJson) => {
            dispatchState({ type: "parse", userJson });
        }

        usePolling('/api/user', { onSuccess }); // <<-- fetch once
    }

    return {
        state,
        api : {
            useGetUser
        }
    }
}