import React, { useRef, useState } from 'react';

export default function Message2Opponent({ getMessage, setMessage }) {
  const [value, setValue] = useState('');
  const syncTimeoutRef = useRef(null);

  const message = getMessage();
  if (value !== message && syncTimeoutRef.current === null) {
    // Absorb external value ONLY if there is no scheduled sync
    setValue(message);
  }

  const disabled = message === undefined;

  /* --- */

  const sync = (nextMessage) => {
    syncTimeoutRef.current = null;
    setMessage(nextMessage);
  }

  const update = (value) => {
    setValue(value);

    clearTimeout(syncTimeoutRef.current); // <<--- Cancel previous sync
    syncTimeoutRef.current = setTimeout(() => sync(value), 500);
  }

  return (
    <input className='Message2Opponent'
      placeholder='Message'
      disabled={disabled}
      value={value || ''}
      maxLength={150}
      onChange={(e) => update(e.target.value)}
    />
  )
}